﻿using HarmonyLib;
using System.Reflection;
using UnityEngine;

public class SeedsFromFruits : Mod
{
    private const string HARMONY_ID = "SeedsFromFruits";
    private Harmony harmonyInstance;

    private int _currentUses1;
    private int _currentUses2;
    private int _currentUses3;
    private int _currentUses4;
    private int _currentUses5;
    private int _currentUses6;
    private int _num1 = Random.Range(1, 4);
    private int _num2 = Random.Range(1, 4);
    private int _num3 = Random.Range(1, 4);
    private int _num4 = Random.Range(1, 4);
    private int _num5 = Random.Range(1, 4);
    private int _num6 = Random.Range(1, 4);

    public void Start()
    {
        ComponentManager<SeedsFromFruits>.Value = this;

        harmonyInstance = new Harmony(HARMONY_ID);
        harmonyInstance.PatchAll(Assembly.GetExecutingAssembly());

        Debug.Log("Mod SeedsFromFruits has been loaded!");
    }

    public void OnModUnload()
    {
        harmonyInstance.UnpatchAll(HARMONY_ID);
        Debug.Log("Mod SeedsFromFruits has been unloaded!");
        Destroy(gameObject);
    }

    public void OnConsumeItem(Item_Base item)
    {
        if (item.name == "Mango")
        {
            GiveMangoSeed();
        }
        else
        {
            if (item.name == "Coconut")
            {
                GiveCoconutSeed();
            }
            else
            {
                if (item.name == "Pineapple")
                {
                    GivePineappleSeed();
                }
                else
                {
                    if (item.name == "Watermelon")
                    {
                        GiveWatermelonSeed();
                    }
                    else
                    {
                        if (item.name == "Strawberry")
                        {
                            GiveStrawberrySeed();
                        }
                        else
                        {
                            if (item.name == "Banana")
                            {
                                GiveBananaSeed();
                            }
                            else
                            {

                            }
                        }
                    }
                }
            }
        }
    }

    public void GiveMangoSeed()
    {
        _currentUses1++;
        if (_currentUses1 > _num1)
        {
            RAPI.GetLocalPlayer().Inventory.AddItem(ItemManager.GetItemByName("Seed_Mango").UniqueName, 1);
            _currentUses1 = 0;
            _num1 = Random.Range(1, 4);

        }
    }

    public void GiveCoconutSeed()
    {
        _currentUses2++;
        if (_currentUses2 > _num2)
        {
            RAPI.GetLocalPlayer().Inventory.AddItem(ItemManager.GetItemByName("Seed_Palm").UniqueName, 1);
            _currentUses2 = 0;
            _num2 = Random.Range(1, 4);

        }
    }

    public void GivePineappleSeed()
    {
        _currentUses3++;
        if (_currentUses3 > _num3)
        {
            RAPI.GetLocalPlayer().Inventory.AddItem(ItemManager.GetItemByName("Seed_Pineapple").UniqueName, 1);
            _currentUses3 = 0;
            _num3 = Random.Range(1, 4);

        }
    }

    public void GiveWatermelonSeed()
    {
        _currentUses4++;
        if (_currentUses4 > _num4)
        {
            RAPI.GetLocalPlayer().Inventory.AddItem(ItemManager.GetItemByName("Seed_Watermelon").UniqueName, 1);
            _currentUses4 = 0;
            _num4 = Random.Range(1, 4);

        }
    }

    public void GiveStrawberrySeed()
    {
        _currentUses5++;
        if (_currentUses5 > _num5)
        {
            RAPI.GetLocalPlayer().Inventory.AddItem(ItemManager.GetItemByName("Seed_Strawberry").UniqueName, 1);
            _currentUses5 = 0;
            _num5 = Random.Range(1, 4);

        }
    }

    public void GiveBananaSeed()
    {
        _currentUses6++;
        if (_currentUses6 > _num6)
        {
            RAPI.GetLocalPlayer().Inventory.AddItem(ItemManager.GetItemByName("Seed_Banana").UniqueName, 1);
            _currentUses6 = 0;
            _num6 = Random.Range(1, 4);

        }
    }

}

[HarmonyPatch(typeof(PlayerStats)), HarmonyPatch("Consume")]
internal class ConsumePatch
{
    private static void Postfix(PlayerStats __instance, Item_Base edibleItem)
    {
        if (__instance.GetComponent(typeof(Network_Player)) == RAPI.GetLocalPlayer())
        {
            ComponentManager<SeedsFromFruits>.Value.OnConsumeItem(edibleItem);
        }
    }
}